EnumMapDeserializer
Date: 2016-12-04

com.fasterxml.jackson.databind.deser.std

## Class EnumMapDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.ContainerDeserializerBase<java.util.EnumMap<?,?>>
      - - com.fasterxml.jackson.databind.deser.std.EnumMapDeserializer

- All Implemented Interfaces:
    ContextualDeserializer, java.io.Serializable

      public class EnumMapDeserializer
      extends ContainerDeserializerBase<java.util.EnumMap<?,?>>
      implements ContextualDeserializer

  Deserializer for `EnumMap` values.

  Note: casting within this class is all messed up -- just could not figure out a way to properly deal with recursive definition of "EnumMap<K extends Enum<K>, V>

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.Class<?>` | `_enumClass`
    `protected KeyDeserializer` | `_keyDeserializer`
    `protected JavaType` | `_mapType`
    `protected JsonDeserializer<java.lang.Object>` | `_valueDeserializer`
    `protected TypeDeserializer` | `_valueTypeDeserializer` If value instances have polymorphic type information, this is the type deserializer that can handle it

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass, F_MASK_INT_COERCIONS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EnumMapDeserializer(JavaType mapType, KeyDeserializer keyDeserializer, JsonDeserializer<?> valueDeser, TypeDeserializer valueTypeDeser)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected java.util.EnumMap<?,?>` | `constructMap()`
    `JsonDeserializer<?>` | `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to finalize setup of this deserializer, when it is known for which property deserializer is needed for.
    `java.util.EnumMap<?,?>` | `deserialize(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `java.lang.Object` | `deserializeWithType(com.fasterxml.jackson.core.JsonParser jp, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
    `JsonDeserializer<java.lang.Object>` | `getContentDeserializer()` Accesor for deserializer use for deserializing content values.
    `JavaType` | `getContentType()` Accessor for declared type of contained value elements; either exact type, or one of its supertypes.
    `boolean` | `isCachable()` Because of costs associated with constructing Enum resolvers, let's cache instances by default.
    `EnumMapDeserializer` | `withResolved(KeyDeserializer keyDeserializer, JsonDeserializer<?> valueDeserializer, TypeDeserializer valueTypeDeser)`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.ContainerDeserializerBase

      `findBackReference, wrapAndThrow`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_coerceIntegral, _deserializeFromEmpty, _failDoubleToIntCoercion, _hasTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _parseBoolean, _parseBooleanFromInt, _parseBooleanFromOther, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, _parseString, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, getValueClass, getValueType, handledType, handleMissingEndArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `deserialize, getDelegatee, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullValue, getNullValue, getObjectIdReader, replaceDelegatee, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _mapType

          protected final JavaType _mapType

    - #### _enumClass

          protected final java.lang.Class<?> _enumClass

    - #### _keyDeserializer

          protected KeyDeserializer _keyDeserializer

    - #### _valueDeserializer

          protected JsonDeserializer<java.lang.Object> _valueDeserializer

    - #### _valueTypeDeserializer

          protected final TypeDeserializer _valueTypeDeserializer

      If value instances have polymorphic type information, this is the type deserializer that can handle it

  - ### Constructor Detail

    - #### EnumMapDeserializer

          public EnumMapDeserializer(JavaType mapType,
                             KeyDeserializer keyDeserializer,
                             JsonDeserializer<?> valueDeser,
                             TypeDeserializer valueTypeDeser)

  - ### Method Detail

    - #### withResolved

          public EnumMapDeserializer withResolved(KeyDeserializer keyDeserializer,
                                         JsonDeserializer<?> valueDeserializer,
                                         TypeDeserializer valueTypeDeser)

    - #### createContextual

          public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                             BeanProperty property)
                                               throws JsonMappingException

      Method called to finalize setup of this deserializer, when it is known for which property deserializer is needed for.
      Specified by:
        `createContextual` in interface `ContextualDeserializer`
      Parameters:
        `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
        `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
      Returns:
        Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

    - #### isCachable

          public boolean isCachable()

      Because of costs associated with constructing Enum resolvers, let's cache instances by default.
      Overrides:
        `isCachable` in class `JsonDeserializer<java.util.EnumMap<?,?>>`

    - #### getContentType

          public JavaType getContentType()

      Description copied from class: `ContainerDeserializerBase`
      Accessor for declared type of contained value elements; either exact type, or one of its supertypes.
      Specified by:
        `getContentType` in class `ContainerDeserializerBase<java.util.EnumMap<?,?>>`

    - #### getContentDeserializer

          public JsonDeserializer<java.lang.Object> getContentDeserializer()

      Description copied from class: `ContainerDeserializerBase`
      Accesor for deserializer use for deserializing content values.
      Specified by:
        `getContentDeserializer` in class `ContainerDeserializerBase<java.util.EnumMap<?,?>>`

    - #### deserialize

          public java.util.EnumMap<?,?> deserialize(com.fasterxml.jackson.core.JsonParser p,
                                           DeserializationContext ctxt)
                                             throws java.io.IOException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

      The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

                {
                    "@class": "class name",
                    ...
                }

      Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

                 if (jp.getCurrentToken() == JsonToken.START_OBJECT) {
                   jp.nextToken();
                 }

      This results in the stream pointing to the field name, so that the two conditions align.

      Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<java.util.EnumMap<?,?>>`
      Parameters:
        `p` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `java.io.IOException`

    - #### deserializeWithType

          public java.lang.Object deserializeWithType(com.fasterxml.jackson.core.JsonParser jp,
                                             DeserializationContext ctxt,
                                             TypeDeserializer typeDeserializer)
                                               throws java.io.IOException,
                                                      com.fasterxml.jackson.core.JsonProcessingException

      Description copied from class: `StdDeserializer`
      Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.
      Overrides:
        `deserializeWithType` in class `StdDeserializer<java.util.EnumMap<?,?>>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `java.io.IOException`
        `com.fasterxml.jackson.core.JsonProcessingException`

    - #### constructMap

          protected java.util.EnumMap<?,?> constructMap()